﻿@page "/HomePage"
@using SquirtingElephant.WebApp.Interfaces
@using SquirtingElephant.WebApp.Models.Dto
@using SquirtingElephant.WebApp.Models.Request
@inject IImageService ImageService;
@using BlazorInputFile
@using System.IO

<h3>HomePage</h3>

@if (!string.IsNullOrWhiteSpace(Picture))
{
    <img src="data:image/png;base64,@Picture"/>
}

<InputFile OnChange="HandleFileSelected"/>
<br>
<button class="btn btn-primary" @onclick="UploadFile">Upload</button>
<br>
@if (Images == null)
{
    <text>Loading...</text>
}
else if (Images.Count == 0)
{
    <text>No Images Found</text>
}
else
{
    <table class="table table-hover table-primary">
        <thead>
        <tr>
            <th>Image</th>
            <th>Date</th>
        </tr>
        </thead>
        <tbody>
        @foreach (var image in Images)
        {
            <tr>
                <td>
                    @image.Image
                </td>
                <td>
                    @image.CreatedDate
                </td>
            </tr>
        }
        </tbody>
    </table>
}

@code {
    private List<ImageDto> Images { get; set; } = null;
    private string Picture { get; set; }
    private string Error { get; set; }
    protected override Task OnInitializedAsync()
    {
        return LoadData();
    }

    private async Task UploadFile()
    {
        var (imageDto, errorResponse) = await ImageService.CreateImage(new CreateImageRequest()
        {
            Image = Picture,
            Token = await LocalStorageService.GetItemAsStringAsync("access_token")
        });
        if (imageDto != null)
        {
            Error = "";
            Picture = "";
            await LoadData();
        }
        else
        {
            Error = errorResponse.Message;
        }
    }

    private async Task LoadData()
    {
        var (getImagesResponse, errorResponse) = await ImageService.GetImages(new GetPageRequest()
        {
            Page = 1,
            PageSize = 10,
            Token = await LocalStorageService.GetItemAsStringAsync("access_token")
        });
        if (getImagesResponse != null)
        {
            Images = getImagesResponse.Data;
        }
        else
        {
            Error = errorResponse.Message;
        }
    }

    private async Task HandleFileSelected(IFileListEntry[] files)
    {
        try
        {
            if (files != null && files.Any())
            {
                var file = files.First();
                using (MemoryStream m = new MemoryStream())
                {
                    await file.Data.CopyToAsync(m);
                    string base64String = Convert.ToBase64String(m.ToArray());
                    Picture = base64String;
                    Console.WriteLine(base64String);

                }
            }
        }
        catch (Exception ex)
        {
            Console.WriteLine(ex);
        }

    }

}